select
    est.descricao as "Estao de Monta"
    , est.dtinicio
    , est.dtfim
    , an.numero as "Nmero"
    , ((select count (*)
          from reproducao re
          where re.cdanimal = esta.cdanimal
            and re.cdtiporeproducao = 7
            and re.data < est.dtinicio)
          + coalesce(an.numpartoentrada,0)) as Ordem_parto
    , ia1.data as "1 Inseminao"
    , (case
        when dig1.diagnostico is null and ia1.cdreproducao is not null then 'sem dig'
        else dig1.diagnostico end)as "1 Diagnostico"
    , ia2.data as "2 Inseminao"
    , (case
        when dig2.diagnostico is null and ia2.cdreproducao is not null then 'sem dig'
        else dig2.diagnostico end) as "2 Diagnostico"
    , ia3.data as "3 Inseminao"
    , (case
        when dig3.diagnostico is null and ia3.cdreproducao is not null then 'sem dig'
        else dig3.diagnostico end) as "3 Diagnostico"
    , ia4.data as "4 Inseminao"
    , (case
        when dig4.diagnostico is null and ia4.cdreproducao is not null then 'sem dig'
        else dig4.diagnostico end) as "4 Diagnostico"
    , rep.data as "Repasse"
    , (case
        when dig5.diagnostico is null and rep.cdreproducao is not null then 'sem dig'
        else dig5.diagnostico end) as "Diagnostico Repasse"
    , (case
        when gra.cdgruporepasse > 0 then 'Sim'
        else 'No' end) as "Grupo de Repasse"
    , (case cat.cdcategoria
        when 1 then 'Insem./Cob.'
        when 2 then 'Implant.'
        when 3 then 'Gestante' || (case
                                    when rep.cdreproducao is not null then ' - Repasse'
                                    when ia1.cdreproducao is not null and ia2.cdreproducao is not null and ia3.cdreproducao is not null and ia4.cdreproducao is not null then ' - 4 IA'
                                    when ia1.cdreproducao is not null and ia2.cdreproducao is not null and ia3.cdreproducao is not null then ' - 3 IA'
                                    when ia1.cdreproducao is not null and ia2.cdreproducao is not null then ' - 2 IA'
                                    when ia1.cdreproducao is not null then ' - 1 IA'
                                    else null end)
        when 4 then 'Vazia'
        else cat.cdcategoria end) as "Situacao Final"
from animal an
    join estacaoanimal esta on esta.cdanimal = an.cdanimal
    join estacao est on est.cdestacao = esta.cdestacao
    left join categoria cat on cat.cdcategoria =
        (select creprodutiva from sp_categoriaanimal(est.dtfim, ' cdanimal = ' || esta.cdanimal))
    left join reproducao ia1 on ia1.cdreproducao =
        (select first 1 re.cdreproducao
        from reproducao re
        where re.cdanimal = esta.cdanimal
            and cdtiporeproducao = 1
            and re.data between est.dtinicio and est.dtfim
        order by re.data asc)
    left join reproducao ia2 on ia2.cdreproducao =
        (select first 1 re.cdreproducao
        from reproducao re
        where re.cdanimal = esta.cdanimal
            and re.cdtiporeproducao = 1
            and re.data > ia1.data
            and re.data between est.dtinicio and est.dtfim
        order by re.data asc)
    left join reproducao ia3 on ia3.cdreproducao =
        (select first 1 re.cdreproducao
        from reproducao re
        where re.cdanimal = esta.cdanimal
            and re.cdtiporeproducao = 1
            and re.data > ia2.data
            and re.data between est.dtinicio and est.dtfim
        order by re.data asc)
    left join reproducao ia4 on ia4.cdreproducao =
        (select first 1 re.cdreproducao
        from reproducao re
        where re.cdanimal = esta.cdanimal
            and re.cdtiporeproducao = 1
            and re.data > ia3.data
            and re.data between est.dtinicio and est.dtfim
        order by re.data asc)
    left join reproducao rep on rep.cdreproducao =
        (select first 1 re.cdreproducao
        from reproducao re
        where re.cdanimal = esta.cdanimal
            and re.cdtiporeproducao = 2
            and re.data between est.dtinicio and est.dtfim
        order by re.data asc)
    left join reproducao dig1 on dig1.cdreproducao =
        (select first 1 re.cdreproducao
        from reproducao re
        where re.cdanimal = esta.cdanimal
            and re.cdtiporeproducao = 4
            and re.diagnostico is not null
            and re.data between ia1.data and coalesce(ia2.data, est.dtfim)
        order by re.data asc)
    left join reproducao dig2 on dig2.cdreproducao =
        (select first 1 re.cdreproducao
        from reproducao re
        where re.cdanimal = esta.cdanimal
            and re.cdtiporeproducao = 4
            and re.diagnostico is not null
            and re.data between ia2.data and coalesce(ia3.data, est.dtfim)
        order by re.data asc)
    left join reproducao dig3 on dig3.cdreproducao =
        (select first 1 re.cdreproducao
        from reproducao re
        where re.cdanimal = esta.cdanimal
            and re.cdtiporeproducao = 4
            and re.diagnostico is not null
            and re.data between ia3.data and coalesce(ia4.data, est.dtfim)
        order by re.data asc)
    left join reproducao dig4 on dig4.cdreproducao =
        (select first 1 re.cdreproducao
        from reproducao re
        where re.cdanimal = esta.cdanimal
            and re.cdtiporeproducao = 4
            and re.diagnostico is not null
            and re.data between ia4.data and coalesce(rep.data, est.dtfim)
        order by re.data asc)
    left join reproducao dig5 on dig5.cdreproducao =
        (select first 1 re.cdreproducao
        from reproducao re
        where re.cdanimal = esta.cdanimal
            and re.cdtiporeproducao = 4
            and re.diagnostico is not null
            and re.data between rep.data and est.dtfim
        order by re.data asc)
    left join gruporepasseanimal gra on gra.cdgruporepasseanimal =
        (select first 1 re.cdgruporepasseanimal
        from gruporepasseanimal re
        where re.cdanimal = esta.cdanimal
            and re.cdgruporepasse in
              (select regp.cdgruporepasse
              from gruporepasse regp
              where (regp.dtfim >= est.dtinicio)and(regp.dtinicio <= est.dtfim)))
